export interface TokenValue<T = unknown> {
    __type: T;
    __symbol: symbol;
    __isOptional: boolean;
}
export interface RequiredToken<T = unknown> extends TokenValue<T> {
    __isOptional: false;
}
export interface OptionalToken<T = unknown> extends TokenValue<T> {
    __isOptional: true;
}
export interface Token<T = unknown> extends RequiredToken<T> {
    optional: OptionalToken<T>;
}
export declare type TokenType<T extends TokenValue> = T extends RequiredToken ? T['__type'] : T['__type'] | undefined;
export declare type TokenTypeMap<T> = {
    [K in keyof T]: T[K] extends Token ? TokenType<T[K]> : TokenTypeMap<T[K]>;
};
export declare type ToToken<T> = undefined extends T ? OptionalToken<Exclude<T, undefined>> : RequiredToken<T>;
export declare const token: <T>(description: string) => Token<T>;
